Index: palm/trunk/SOURCE/shared_memory_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4893)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! additions for output of particle time series
 !
@@ -39,7 +42,5 @@
 ! unused variable removed
 !
-! 
 ! Additions for cyclic fill mode
-!
 ! 
 ! File re-formatted to follow the PALM coding standard
@@ -47,6 +48,4 @@
 !
 ! Initial version (Klaus Ketelsen)
-!
-!
 !
 ! Description:
@@ -100,4 +99,5 @@
               comm1dy,                                                                             &
               comm2d,                                                                              &
+              comm_palm,                                                                           &
               ierr,                                                                                &
               myid,                                                                                &
@@ -120,4 +120,7 @@
 #endif
 
+    USE transpose_indices,                                                                         &
+        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nys_x, nys_z, nyn_x, nyn_z, nzb_x, nzb_y, nzt_x, nzt_y
+
     IMPLICIT NONE
 
@@ -149,4 +152,18 @@
     END TYPE domain_decomposition_grid_features
 
+    TYPE, PUBLIC ::  sm_remote_array
+
+       TYPE(C_PTR)  ::  rem_ptr  !<
+       INTEGER(iwp) ::  d1e      !<
+       INTEGER(iwp) ::  d1s      !<
+       INTEGER(iwp) ::  d2e      !<
+       INTEGER(iwp) ::  d2s      !<
+       INTEGER(iwp) ::  d3e      !<
+       INTEGER(iwp) ::  d3s      !<
+       INTEGER(iwp) ::  d4e      !<
+       INTEGER(iwp) ::  d4s      !<
+
+    END TYPE sm_remote_array
+
 !
 !-- Class definition for shared memory instances.
@@ -164,19 +181,20 @@
        INTEGER(iwp), PUBLIC ::  sh_rank       !<
 
-       LOGICAL, PUBLIC ::  iam_io_pe = .TRUE.  !< This PE is an IO-PE
 !
 !--    Variables for the I/O virtual grid
-       INTEGER(iwp), PUBLIC ::  comm_io  !< Communicator for all IO processes
+       INTEGER(iwp), PUBLIC ::  comm_io  !< communicator for all IO processes
        INTEGER(iwp), PUBLIC ::  io_npes  !<
        INTEGER(iwp), PUBLIC ::  io_rank  !<
 !
 !--    Variables for the node local communicator
-       INTEGER(iwp) ::  comm_node          !< Communicator for all processes of current node
+       INTEGER(iwp) ::  comm_node          !< communicator for all processes of current node
        INTEGER(iwp) ::  io_pe_global_rank  !<
        INTEGER(iwp) ::  n_npes             !<
        INTEGER(iwp) ::  n_rank             !<
 
-       TYPE(domain_decomposition_grid_features), PUBLIC ::  io_grid  !< io grid features, depending on reading from prerun or restart run
-
+       LOGICAL, PUBLIC ::  is_root_pe          !<
+       LOGICAL, PUBLIC ::  iam_io_pe = .TRUE.  !< this PE is an IO-PE
+
+       TYPE(domain_decomposition_grid_features), PUBLIC ::  io_grid  !< io grid features, depending on reading from prerun or main run
 
        CONTAINS
@@ -191,21 +209,27 @@
           PROCEDURE, PASS(this), PUBLIC ::  sm_node_barrier
 #if defined( __parallel )
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1d_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1d_64
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1d_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1di
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2d_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2d_64
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2d_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2di
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3d_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3d_64
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3d_32
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_4d_32
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_4d_64
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3di_32
           PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3di_64
+          PROCEDURE, PASS(this), PUBLIC ::  sm_all_allocate_shared_3d_64
 
           GENERIC, PUBLIC ::  sm_allocate_shared =>                                                &
-                                              sm_allocate_shared_1d_64,  sm_allocate_shared_1d_32, &
-                                              sm_allocate_shared_2d_64,  sm_allocate_shared_2d_32, &
-                                              sm_allocate_shared_2di,    sm_allocate_shared_3d_64, &
-                                              sm_allocate_shared_3d_32,  sm_allocate_shared_1di,   &
-                                              sm_allocate_shared_3di_32, sm_allocate_shared_3di_64
+                                             sm_allocate_shared_1d_64,  sm_allocate_shared_1d_32,  &
+                                             sm_allocate_shared_2d_64,  sm_allocate_shared_2d_32,  &
+                                             sm_allocate_shared_2di,    sm_allocate_shared_3d_64,  &
+                                             sm_allocate_shared_4d_64,  sm_allocate_shared_4d_32,  &
+                                             sm_allocate_shared_3d_32,  sm_allocate_shared_1di,    &
+                                             sm_allocate_shared_3di_32, sm_allocate_shared_3di_64
+
+          GENERIC, PUBLIC ::  sm_all_allocate_shared => sm_all_allocate_shared_3d_64
 #endif
     END TYPE sm_class
@@ -226,9 +250,9 @@
 
     CLASS(sm_class), INTENT(INOUT) ::  this        !< pointer to access internal variables of this call
-    INTEGER, INTENT(IN), OPTIONAL  ::  comm_input  !< main model communicator (comm2d) can optional be set
+    INTEGER(iwp), INTENT(IN), OPTIONAL ::  comm_input  !< main model communicator (comm2d) can optional be set
 
 #if defined( __parallel )
-    INTEGER ::  color
-    INTEGER ::  max_n_npes  !< maximum number of PEs/node
+    INTEGER ::  color              !<
+    INTEGER ::  max_npes_per_node  !< maximum number of PEs/node
 #endif
 
@@ -237,4 +261,5 @@
     this%nr_io_pe_per_node = 2
 
+#if defined( __parallel )
     IF ( PRESENT( comm_input ) )  THEN
        this%comm_model = comm_input
@@ -248,10 +273,11 @@
     IF ( this%no_shared_memory_in_this_run )  THEN
        this%iam_io_pe = .TRUE.
+       this%sh_rank   = 0
+       this%sh_npes   = 1
        RETURN
     ENDIF
 
-#if defined( __parallel )
-!
-!-- Determine, how many MPI threads are running on a node
+!
+!-- Determine, how many PEs are running on a node.
     this%iam_io_pe = .FALSE.
     CALL MPI_COMM_SPLIT_TYPE( this%comm_model, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL,             &
@@ -260,15 +286,16 @@
     CALL MPI_COMM_RANK( this%comm_node, this%n_rank, ierr )
 
-    CALL MPI_ALLREDUCE( this%n_npes, max_n_npes, 1, MPI_INTEGER, MPI_MAX, this%comm_model, ierr )
+    CALL MPI_ALLREDUCE( this%n_npes, max_npes_per_node, 1, MPI_INTEGER, MPI_MAX, this%comm_model,  &
+                        ierr )
 !
 !-- Decide, if the configuration can run with shared-memory IO
-    IF ( max_n_npes > 64 )  THEN
+    IF ( max_npes_per_node > 64 )  THEN
 !
 !--    Special configuration on the HLRN-IV system with 4 shared memory blocks/node
        this%nr_io_pe_per_node = 4
 
-    ELSEIF ( max_n_npes <= 32 )  THEN
-!
-!--    No shared memory IO with less than 32 threads/node
+    ELSEIF ( max_npes_per_node <= 3 )  THEN
+!
+!--    No shared memory IO with less than 3 MPI tasks/node
        this%no_shared_memory_in_this_run = .TRUE.
        this%iam_io_pe = .TRUE.
@@ -277,6 +304,6 @@
 
 !
-!-- No shared memory IO with small setups
-    IF ( nx < 24  .OR.  ny < 24 )  THEN
+!-- No shared memory IO with small setups.
+    IF ( nx < 16  .OR.  ny < 16 )  THEN
        this%no_shared_memory_in_this_run = .TRUE.
        this%iam_io_pe = .TRUE.
@@ -299,5 +326,5 @@
 !
 !-- Setup the communicator across the nodes depending on the shared memory rank.
-!-- All threads with shared memory rank 0 will be I/O threads.
+!-- All PEs with shared memory rank 0 will be I/O PEs.
     color = this%sh_rank
     CALL MPI_COMM_SPLIT( this%comm_model, color, 0, this%comm_io, ierr )
@@ -316,11 +343,11 @@
     ENDIF
     CALL MPI_BCAST( this%io_pe_global_rank, 1, MPI_INTEGER, 0, this%comm_shared, ierr )
-
 #else
-    this%iam_io_pe = .TRUE.
+    this%iam_io_pe  = .TRUE.
+    this%comm_model = comm2d
+    this%sh_rank    = 0
+    this%sh_npes    = 1
+    this%no_shared_memory_in_this_run = .TRUE.
 #endif
-
-!      write(9,'(a,8i7)') ' end of sm_init_comm ',this%sh_rank,this%sh_npes,this%io_rank,this%io_npes,this%io_pe_global_rank
-!      write(9,*) 'This process is IO Process ',this%iam_io_pe
 
 #if defined( __parallel )
@@ -362,5 +389,5 @@
     CALL MPI_ALLREDUCE( local_dim_s, local_dim_r, SIZE( local_dim_s ), MPI_INTEGER, MPI_SUM,       &
                         this%comm_node, ierr )
-    sh_group_size = ( max_n_npes + this%nr_io_pe_per_node - 1 ) / this%nr_io_pe_per_node
+    sh_group_size = ( max_npes_per_node + this%nr_io_pe_per_node - 1 ) / this%nr_io_pe_per_node
 
     pe       = 0
@@ -417,5 +444,4 @@
  END SUBROUTINE sm_init_comm
 
-
 !
 !-- Initializing setup for output of particle time series.
@@ -428,7 +454,7 @@
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  color             !<
-    INTEGER(iwp) ::  ierr              !<
-    INTEGER(iwp) ::  max_n_npes        !< maximum number of PEs/node
+    INTEGER(iwp) ::  color              !<
+    INTEGER(iwp) ::  ierr               !<
+    INTEGER(iwp) ::  max_npes_per_node  !< maximum number of PEs/node
 #endif
 
@@ -451,5 +477,5 @@
 #if defined( __parallel )
 !
-!-- Determine, how many MPI threads are running on a node
+!-- Determine, how many PEs are running on a node.
     this%iam_io_pe = .FALSE.
     CALL MPI_COMM_SPLIT_TYPE( this%comm_model, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL,             &
@@ -458,6 +484,6 @@
     CALL MPI_COMM_RANK( this%comm_node, this%n_rank, ierr )
 
-    CALL MPI_ALLREDUCE( this%n_npes, max_n_npes, 1, MPI_INTEGER, MPI_MAX, this%comm_model, ierr )
-
+    CALL MPI_ALLREDUCE( this%n_npes, max_npes_per_node, 1, MPI_INTEGER, MPI_MAX, this%comm_model,  &
+                        ierr )
 !
 !-- TODO: better explanation
@@ -465,6 +491,6 @@
 !-- even better to use the complete node for MPI shared memory (this%nr_io_pe_per_node = 1).
 !-  In the latter case, the access to the MPI shared memory buffer is slower, the number of
-!-- particles to move between threads will be much smaller.
-    IF ( max_n_npes > 64 )  THEN
+!-- particles to move between PEs will be much smaller.
+    IF ( max_npes_per_node > 64 )  THEN
 !
 !--    Special configuration on the HLRN-IV system with 4 shared memory blocks/node
@@ -526,5 +552,5 @@
 !
 !-- Setup the communicator across the nodes depending on the shared memory rank.
-!-- All threads with shared memory rank 0 will be I/O threads.
+!-- All PEs with shared memory rank 0 will be I/O PEs.
     color = this%sh_rank
     CALL MPI_COMM_SPLIT( this%comm_model, color, 0, this%comm_io, ierr )
@@ -573,5 +599,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 1d-REAL (64 Bit) array on ALL threads
+!> Allocate shared 1d-REAL (64 bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_1d_64( this, p1, d1, d2, win )
@@ -590,5 +616,5 @@
     INTEGER(KIND=MPI_ADDRESS_KIND)  ::  wsize
 
-    INTEGER, DIMENSION(1)           ::  buf_shape
+    INTEGER(iwp), DIMENSION(1)      ::  buf_shape
 
     REAL(dp), DIMENSION(:), POINTER ::  buf
@@ -601,5 +627,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = d2 - d1 + 1
@@ -629,5 +655,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 1d-REAL (32 Bit) array on ALL threads
+!> Allocate shared 1d-REAL (32 bit) array on PE 0 and pass address to all PEs
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_1d_32( this, p1, d1, d2, win )
@@ -646,5 +672,5 @@
     INTEGER(KIND=MPI_ADDRESS_KIND)  ::  wsize
 
-    INTEGER, DIMENSION(1)           ::  buf_shape
+    INTEGER(iwp), DIMENSION(1)      ::  buf_shape
 
     REAL(sp), DIMENSION(:), POINTER ::  buf
@@ -657,5 +683,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = d2 - d1 + 1
@@ -685,5 +711,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 1d-INTEGER array on ALL threads
+!> Allocate shared 1d-INTEGER array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_1di( this, p1, d1, d2, win )
@@ -702,5 +728,5 @@
     INTEGER(KIND=MPI_ADDRESS_KIND)  ::  wsize
 
-    INTEGER, DIMENSION(1)           ::  buf_shape
+    INTEGER(iwp), DIMENSION(1)          ::  buf_shape
 
     INTEGER(iwp), DIMENSION(:), POINTER ::  buf
@@ -713,5 +739,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = d2 - d1 + 1
@@ -741,5 +767,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 2d-REAL array on ALL threads (64 Bit)
+!> Allocate shared 2d-REAL array (64 bit) on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_2d_64( this, p2, n_nxlg, n_nxrg, n_nysg, n_nyng, win )
@@ -771,5 +797,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( n_nyng - n_nysg + 1 ) * ( n_nxrg - n_nxlg + 1 )
@@ -801,5 +827,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 2d-REAL (32 Bit) array on ALL threads
+!> Allocate shared 2d-REAL (32 Bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_2d_32( this, p2, n_nxlg, n_nxrg, n_nysg, n_nyng, win )
@@ -831,5 +857,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( n_nyng - n_nysg + 1 ) * ( n_nxrg - n_nxlg + 1 )
@@ -861,5 +887,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 2d-INTEGER array on ALL threads
+!> Allocate shared 2d-INTEGER array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_2di( this, p2i, n_nxlg, n_nxrg, n_nysg, n_nyng, win )
@@ -891,5 +917,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( n_nyng - n_nysg + 1 ) * ( n_nxrg - n_nxlg + 1 )
@@ -921,5 +947,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 3d-REAL (64 Bit) array on ALL threads
+!> Allocate shared 3d-REAL (64 bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_3d_64( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, win )
@@ -929,18 +955,18 @@
     CLASS(sm_class), INTENT(inout)      ::  this         !<
 
-    INTEGER                             ::  disp_unit    !<
-    INTEGER, INTENT(IN)                 ::  d1e          !<
-    INTEGER, INTENT(IN)                 ::  d1s          !<
-    INTEGER, INTENT(IN)                 ::  d2e          !<
-    INTEGER, INTENT(IN)                 ::  d2s          !<
-    INTEGER, INTENT(IN)                 ::  d3e          !<
-    INTEGER, INTENT(IN)                 ::  d3s          !<
-    INTEGER, SAVE                       ::  pe_from = 0  !<
-    INTEGER, INTENT(OUT)                ::  win          !<
+    INTEGER(iwp)                        ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)            ::  d1e          !<
+    INTEGER(iwp), INTENT(IN)            ::  d1s          !<
+    INTEGER(iwp), INTENT(IN)            ::  d2e          !<
+    INTEGER(iwp), INTENT(IN)            ::  d2s          !<
+    INTEGER(iwp), INTENT(IN)            ::  d3e          !<
+    INTEGER(iwp), INTENT(IN)            ::  d3s          !<
+    INTEGER(iwp), SAVE                  ::  pe_from = 0  !<
+    INTEGER(iwp), INTENT(OUT)           ::  win          !<
 
     INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size     !<
     INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize        !<
 
-    INTEGER, DIMENSION(3)               ::  buf_shape    !<
+    INTEGER(iwp), DIMENSION(3)          ::  buf_shape    !<
 
     REAL(dp), DIMENSION(:,:,:), POINTER ::  buf          !<
@@ -953,5 +979,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
@@ -984,5 +1010,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 3d-REAL (32 Bit) array on ALL threads
+!> Allocate shared 3d-REAL (32 bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_3d_32( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, win )
@@ -992,18 +1018,18 @@
     CLASS(sm_class), INTENT(inout)      ::  this
 
-    INTEGER                             ::  disp_unit
-    INTEGER, INTENT(IN)                 ::  d1e
-    INTEGER, INTENT(IN)                 ::  d1s
-    INTEGER, INTENT(IN)                 ::  d2e
-    INTEGER, INTENT(IN)                 ::  d2s
-    INTEGER, INTENT(IN)                 ::  d3e
-    INTEGER, INTENT(IN)                 ::  d3s
-    INTEGER, SAVE                       ::  pe_from = 0
-    INTEGER, INTENT(OUT)                ::  win
+    INTEGER(iwp)                        ::  disp_unit
+    INTEGER(iwp), INTENT(IN)            ::  d1e
+    INTEGER(iwp), INTENT(IN)            ::  d1s
+    INTEGER(iwp), INTENT(IN)            ::  d2e
+    INTEGER(iwp), INTENT(IN)            ::  d2s
+    INTEGER(iwp), INTENT(IN)            ::  d3e
+    INTEGER(iwp), INTENT(IN)            ::  d3s
+    INTEGER(iwp), SAVE                  ::  pe_from = 0
+    INTEGER(iwp), INTENT(OUT)           ::  win
 
     INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size
     INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize
 
-    INTEGER, DIMENSION(3)               ::  buf_shape
+    INTEGER(iwp), DIMENSION(3)          ::  buf_shape
 
     REAL(sp), DIMENSION(:,:,:), POINTER ::  buf
@@ -1016,5 +1042,5 @@
     IF ( this%no_shared_memory_in_this_run )  RETURN
 !
-!-- Allocate shared memory on node rank 0 threads.
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
@@ -1047,5 +1073,137 @@
 ! Description:
 ! ------------
-!> Allocate shared 3d-REAL (32 bit) array on ALL threads
+!> Allocate shared 4d-REAL (64 bit) array on PE 0 and pass address to all PEs.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE sm_allocate_shared_4d_64( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, d4s, d4e, win )
+
+    IMPLICIT NONE
+
+    CLASS(sm_class), INTENT(inout)        ::  this         !<
+
+    INTEGER                               ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)              ::  d1e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d1s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d2e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d2s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d3e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d3s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d4e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d4s          !<
+    INTEGER(iwp), SAVE                    ::  pe_from = 0  !<
+    INTEGER(iwp), INTENT(OUT)             ::  win          !<
+
+    INTEGER(KIND=MPI_ADDRESS_KIND)        ::  rem_size     !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)        ::  wsize        !<
+
+    INTEGER(iwp), DIMENSION(4)            ::  buf_shape    !<
+
+    REAL(dp), DIMENSION(:,:,:,:), POINTER ::  buf          !<
+    REAL(dp), DIMENSION(:,:,:,:), POINTER ::  p3           !<
+
+    TYPE(C_PTR), SAVE                     ::  base_ptr     !<
+    TYPE(C_PTR), SAVE                     ::  rem_ptr      !<
+
+
+    IF ( this%no_shared_memory_in_this_run )  RETURN
+!
+!-- Allocate shared memory on node rank 0 PEs.
+    IF ( this%sh_rank == pe_from )  THEN
+       wsize = (d4e - d4s +1) * ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
+    ELSE
+       wsize = 1
+    ENDIF
+
+    wsize = wsize * dp ! Please note, size is always in bytes, independently of the displacement
+                       ! unit
+
+    CALL MPI_WIN_ALLOCATE_SHARED( wsize, dp, MPI_INFO_NULL, this%comm_shared, base_ptr, win, ierr )
+!
+!-- Get C-pointer of the memory located on node-rank pe_from (sh_rank == pe_from)
+    CALL MPI_WIN_SHARED_QUERY( win, pe_from, rem_size, disp_unit, rem_ptr, ierr )
+!
+!-- Convert C- to Fortran-pointer
+    buf_shape(4) = d4e - d4s + 1
+    buf_shape(3) = d3e - d3s + 1
+    buf_shape(2) = d2e - d2s + 1
+    buf_shape(1) = d1e - d1s + 1
+    CALL C_F_POINTER( rem_ptr, buf, buf_shape )
+    p3(d1s:,d2s:,d3s:,d4s:) => buf
+!
+!-- Allocate shared memory in round robin on all PEs of a node.
+    pe_from = MOD( pe_from, this%sh_npes )
+
+ END SUBROUTINE sm_allocate_shared_4d_64
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Allocate shared 4d-REAL (32 bit) array on PE 0 and pass address to all PEs.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE sm_allocate_shared_4d_32( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, d4s, d4e, win )
+
+    IMPLICIT NONE
+
+    CLASS(sm_class), INTENT(inout)        ::  this         !<
+
+    INTEGER                               ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)              ::  d1e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d1s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d2e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d2s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d3e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d3s          !<
+    INTEGER(iwp), INTENT(IN)              ::  d4e          !<
+    INTEGER(iwp), INTENT(IN)              ::  d4s          !<
+    INTEGER(iwp), SAVE                    ::  pe_from = 0  !<
+    INTEGER(iwp), INTENT(OUT)             ::  win          !<
+
+    INTEGER(KIND=MPI_ADDRESS_KIND)        ::  rem_size     !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)        ::  wsize        !<
+
+    INTEGER(iwp), DIMENSION(4)            ::  buf_shape    !<
+
+    REAL(sp), DIMENSION(:,:,:,:), POINTER ::  buf          !<
+    REAL(sp), DIMENSION(:,:,:,:), POINTER ::  p3           !<
+
+    TYPE(C_PTR), SAVE                     ::  base_ptr     !<
+    TYPE(C_PTR), SAVE                     ::  rem_ptr      !<
+
+
+    IF ( this%no_shared_memory_in_this_run )  RETURN
+!
+!-- Allocate shared memory on node rank 0 PEs.
+    IF ( this%sh_rank == pe_from )  THEN
+       wsize = (d4e - d4s +1) * ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
+    ELSE
+       wsize = 1
+    ENDIF
+
+    wsize = wsize * sp ! Please note, size is always in bytes, independently of the displacement
+                       ! unit
+
+    CALL MPI_WIN_ALLOCATE_SHARED( wsize, dp, MPI_INFO_NULL, this%comm_shared, base_ptr, win, ierr )
+!
+!-- Get C-pointer of the memory located on node-rank pe_from (sh_rank == pe_from)
+    CALL MPI_WIN_SHARED_QUERY( win, pe_from, rem_size, disp_unit, rem_ptr, ierr )
+!
+!-- Convert C- to Fortran-pointer
+    buf_shape(4) = d4e - d4s + 1
+    buf_shape(3) = d3e - d3s + 1
+    buf_shape(2) = d2e - d2s + 1
+    buf_shape(1) = d1e - d1s + 1
+    CALL C_F_POINTER( rem_ptr, buf, buf_shape )
+    p3(d1s:,d2s:,d3s:,d4s:) => buf
+!
+!-- Allocate shared memory in round robin on all PEs of a node.
+    pe_from = MOD( pe_from, this%sh_npes )
+
+ END SUBROUTINE sm_allocate_shared_4d_32
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Allocate shared 3d-INTEGER (32 bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_3di_32( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, win )
@@ -1053,31 +1211,31 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)      ::  this
-
-    INTEGER                             ::  disp_unit
-    INTEGER, INTENT(IN)                 ::  d1e
-    INTEGER, INTENT(IN)                 ::  d1s
-    INTEGER, INTENT(IN)                 ::  d2e
-    INTEGER, INTENT(IN)                 ::  d2s
-    INTEGER, INTENT(IN)                 ::  d3e
-    INTEGER, INTENT(IN)                 ::  d3s
-    INTEGER, SAVE                       ::  pe_from = 0
-    INTEGER, INTENT(OUT)                ::  win
-
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize
-
-    INTEGER, DIMENSION(3)               ::  buf_shape
+    CLASS(sm_class), INTENT(inout)          ::  this
+
+    INTEGER                                 ::  disp_unit
+    INTEGER(iwp), INTENT(IN)                ::  d1e
+    INTEGER(iwp), INTENT(IN)                ::  d1s
+    INTEGER(iwp), INTENT(IN)                ::  d2e
+    INTEGER(iwp), INTENT(IN)                ::  d2s
+    INTEGER(iwp), INTENT(IN)                ::  d3e
+    INTEGER(iwp), INTENT(IN)                ::  d3s
+    INTEGER(iwp), SAVE                      ::  pe_from = 0
+    INTEGER(iwp), INTENT(OUT)               ::  win
+
+    INTEGER(KIND=MPI_ADDRESS_KIND)          ::  rem_size
+    INTEGER(KIND=MPI_ADDRESS_KIND)          ::  wsize
+
+    INTEGER(iwp), DIMENSION(3)              ::  buf_shape
 
     INTEGER(isp), DIMENSION(:,:,:), POINTER ::  buf
     INTEGER(isp), DIMENSION(:,:,:), POINTER ::  p3
 
-    TYPE(C_PTR), SAVE                   ::  base_ptr
-    TYPE(C_PTR), SAVE                   ::  rem_ptr
-
-
-    IF ( this%no_shared_memory_in_this_run )  RETURN
-!
-!-- Allocate shared memory on node rank 0 threads.
+    TYPE(C_PTR), SAVE                       ::  base_ptr
+    TYPE(C_PTR), SAVE                       ::  rem_ptr
+
+
+    IF ( this%no_shared_memory_in_this_run )  RETURN
+!
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
@@ -1110,5 +1268,5 @@
 ! Description:
 ! ------------
-!> Allocate shared 3d-REAL (64 bit) array on ALL threads
+!> Allocate shared 3d-INTEGER (64 bit) array on PE 0 and pass address to all PEs.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE sm_allocate_shared_3di_64( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, win )
@@ -1116,31 +1274,31 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)      ::  this         !<
-
-    INTEGER                             ::  disp_unit    !<
-    INTEGER, INTENT(IN)                 ::  d1e          !<
-    INTEGER, INTENT(IN)                 ::  d1s          !<
-    INTEGER, INTENT(IN)                 ::  d2e          !<
-    INTEGER, INTENT(IN)                 ::  d2s          !<
-    INTEGER, INTENT(IN)                 ::  d3e          !<
-    INTEGER, INTENT(IN)                 ::  d3s          !<
-    INTEGER, SAVE                       ::  pe_from = 0  !<
-    INTEGER, INTENT(OUT)                ::  win          !<
-
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size     !<
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize        !<
-
-    INTEGER, DIMENSION(3)               ::  buf_shape    !<
+    CLASS(sm_class), INTENT(inout)          ::  this         !<
+
+    INTEGER                                 ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)                ::  d1e          !<
+    INTEGER(iwp), INTENT(IN)                ::  d1s          !<
+    INTEGER(iwp), INTENT(IN)                ::  d2e          !<
+    INTEGER(iwp), INTENT(IN)                ::  d2s          !<
+    INTEGER(iwp), INTENT(IN)                ::  d3e          !<
+    INTEGER(iwp), INTENT(IN)                ::  d3s          !<
+    INTEGER(iwp), SAVE                      ::  pe_from = 0  !<
+    INTEGER(iwp), INTENT(OUT)               ::  win          !<
+
+    INTEGER(KIND=MPI_ADDRESS_KIND)          ::  rem_size     !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)          ::  wsize        !<
+
+    INTEGER(iwp), DIMENSION(3)              ::  buf_shape    !<
 
     INTEGER(idp), DIMENSION(:,:,:), POINTER ::  buf          !<
     INTEGER(idp), DIMENSION(:,:,:), POINTER ::  p3           !<
 
-    TYPE(C_PTR), SAVE                   ::  base_ptr     !<
-    TYPE(C_PTR), SAVE                   ::  rem_ptr      !<
-
-
-    IF ( this%no_shared_memory_in_this_run )  RETURN
-!
-!-- Allocate shared memory on node rank 0 threads.
+    TYPE(C_PTR), SAVE                       ::  base_ptr     !<
+    TYPE(C_PTR), SAVE                       ::  rem_ptr      !<
+
+
+    IF ( this%no_shared_memory_in_this_run )  RETURN
+!
+!-- Allocate shared memory on node rank 0 PEs.
     IF ( this%sh_rank == pe_from )  THEN
        wsize = ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
